c program to extract desired fields from dbSEABED format and print out
c to new file with simpler format also readable into ArcGIS  
c options to not include null grain size format, or eliminate certain
c data keys that are suspect.


c ******************************************************************
c Program written by Dr John GOFF, University of Texas at Austin

c "http://www.ig.utexas.edu/people/staff/goff/"

c Work supported by ONR Awards, 2006-7
c ******************************************************************


      program dataex

      character head*80
      character c*2, inline*140
      real*8 lat,lon
      real gs,sort
      integer gravel,sand,mud,clay,depth,comma(40),datakey

      c = ', '
      open (1,file='PAC_EXT.TXT',status='old')
      open (2,file='pac_ext.data',status='unknown')
      read (1,'(a)') head
      write (2,'(a)') '"lat", "lon", "depth", "top", "base",'//
     #                ' "g", "s", "m", "c", "gs", "sort"'

10    format (f8.5,a2,f10.5,a2,i4,a2,f6.2,a2,f6.2,a2,i3,a2,i3,a2,
     #        i3,a2,i3,a2,f5.1,a2,f5.1)
c20    read (1,*,end=90) lat,lon,depth,top,base,c1, x1, x2, x3, c2, 
c     #                  c3, gravel, sand, mud, clay, gs, sort
20    read (1,'(a)',end=90) inline
      i = 0
      do ic = 1,140
         if (inline(ic:ic) .eq. ',') then
            i = i + 1
            comma(i) = ic
         endif
      enddo
      if (i .lt. 18) write (*,*) 'oops'
      i1 = 1
      i2 = comma(1) - 1
      read (inline(i1:i2),*) lat
      i1 = comma(1) + 1
      i2 = comma(2) - 1
      read (inline(i1:i2),*) lon
      i1 = comma(2) + 1
      i2 = comma(3) - 1
      read (inline(i1:i2),*) depth
      i1 = comma(3) + 1
      i2 = comma(4) - 1
      read (inline(i1:i2),*) top
      i1 = comma(4) + 1
      i2 = comma(5) - 1
      read (inline(i1:i2),*) base
      i1 = comma(6) + 1
      i2 = comma(7) - 1
      read (inline(i1:i2),*) datakey
      i1 = comma(11) + 1
      i2 = comma(12) - 1
      read (inline(i1:i2),*) gravel
      i1 = comma(12) + 1
      i2 = comma(13) - 1
      read (inline(i1:i2),*) sand
      i1 = comma(13) + 1
      i2 = comma(14) - 1
      read (inline(i1:i2),*) mud
      i1 = comma(14) + 1
      i2 = comma(15) - 1
      read (inline(i1:i2),*) clay
      i1 = comma(15) + 1
      i2 = comma(16) - 1
      read (inline(i1:i2),*) gs
      i1 = comma(16) + 1
      i2 = comma(17) - 1
      read (inline(i1:i2),*) sort
      if (gs .ne. -99 .and. datakey .ne. 0) then
         if (lat .gt. 32 .and. lat .lt. 49 .and.
     #       lon .gt. -127 .and. lon .lt. -116) then
            write (2,10) lat,c,lon,c,depth,c,top,c,base,c,gravel,  
     #                   c,sand,c,mud,c,clay,c,gs,c,sort
         endif
      endif

      goto 20
90    close (1)
      close (2)
  
      stop
      end
