
c ******************************************************************
c Program written by Dr John GOFF, University of Texas at Austin

c "http://www.ig.utexas.edu/people/staff/goff/"

c Years 2006-7
c ******************************************************************

      real function gamma(v)

      real v,gm(101),dif,gam,vst
      integer gind,nr,i

      data gm/1.00000,.99433,.98884,.98355,.97844,.97305,.96874,
     #         .96415,.95973,.95546,.95135,.94740,.94359,.93993,
     #         .93642,.93304,.92980,.92670,.92373,.92089,.91817,
     #         .91558,.91311,.91075,.90852,.90640,.90440,.90250,
     #         .90072,.89904,.89747,.89600,.89464,.89338,.89222,
     #         .89115,.89018,.88931,.88854,.88785,.88726,.88676,
     #         .88636,.88604,.88581,.88566,.88560,.88563,.88575,
     #         .88595,.88623,.88659,.88704,.88757,.88818,.88887,
     #         .88964,.89049,.89142,.89243,.89352,.89468,.89592,
     #         .89724,.89864,.90012,.90167,.90330,.90500,.90678,
     #         .90864,.91057,.91258,.91466,.91683,.91906,.92137,
     #         .92376,.92623,.92877,.93138,.93408,.93685,.93969,
     #         .94261,.94561,.94869,.95184,.95507,.95838,.96177,
     #         .96523,.96877,.97240,.97610,.97988,.98374,.98768,
     #         .99171,.99581,1.0000/
               
      if (v .eq. 0.) then 
         gamma = 0. 
         write (*,*) 'gamma function is infinite'
      elseif (v .gt. 0) then
         nr = ifix(v) - 1 
         vst = v - float(nr)
         gind = ifix(100.*(vst-1.)) + 1
         dif = vst - 1. - float(gind-1)/100.
         gam = gm(gind) + (dif/.01)*(gm(gind+1)-gm(gind)) 
         if (nr .eq. 0) then
            gamma = gam
         elseif (nr .gt. 0) then
            do i = 1,nr
               gam = gam*(float(i-1)+vst)
            enddo
            gamma = gam
         elseif (nr .eq. -1) then
            gamma = gam/v
         endif 
      elseif (v .lt. 0) then
         nr = -ifix(v) + 2
         vst = v + float(nr)
         if (vst .eq. 1. .or. vst .eq. 2.) then
            write (*,*) 'gamma function is infinite'
            gamma = 0.
         else
            gind = ifix(100.*(vst-1.)) + 1
            dif = 1.-vst - float(gind-1)/100.
            gam = gm(gind) + (dif/.01)*(gm(gind+1)-gm(gind))
            do i = 1,nr
               gam = gam/(vst-float(i))
            enddo
            gamma = gam 
         endif
      endif

      return    
      end
