#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <memory.h>
#include <pwd.h>
#include <time.h>
#include <sys/file.h>
#include <sys/types.h>
struct GRD_HEADER { 
	int nx;			/* Number of columns */
	int ny;			/* Number of rows */
	int node_offset;	/* 0 for node grids, 1 for pixel grids */
	double x_min;		/* Minimum x coordinate */
	double x_max;		/* Maximum x coordinate */
	double y_min;		/* Minimum y coordinate */
	double y_max;		/* Maximum y coordinate */
	double z_min;		/* Minimum z value */
	double z_max;		/* Maximum z value */
	double x_inc;		/* x increment */
	double y_inc;		/* y increment */
	double z_scale_factor;	/* grd values must be multiplied by this */
	double z_add_offset;	/* After scaling, add this */
	char x_units[80];	/* units in x-direction */
	char y_units[80];	/* units in y-direction */
	char z_units[80];	/* grid value units */
	char title[80];		/* name of data set */
	char command[320];	/* name of generating command */
	char remark[160];	/* comments re this data set */
};

/* fortran interface */
int bin_read_grd_ (file, gh, grid, nlen)
char *file;
float grid[];
struct GRD_HEADER *gh;
int nlen; {
	bin_read_grd (file, gh, grid);
}

int bin_read_grd (file, gh, grid)
char *file;
float *grid;
struct GRD_HEADER *gh;
{
	FILE *fp;
        int nm;
	fp = fopen (file, "r"); 
	fread ((char *)gh, sizeof (struct GRD_HEADER), 1, fp); 
	nm = gh->nx * gh->ny;
	fread ((char *)grid, sizeof (float), nm, fp);

}

/* fortran interface */
int bin_write_grd_ (file, gh, grid, nlen)
char *file;
struct GRD_HEADER *gh;
float grid[];
int nlen; {
	bin_write_grd (file, gh, grid);
}

int bin_write_grd (file, gh, grid)
char *file;
struct GRD_HEADER *gh;
float *grid;
{
	FILE *fp;
        int nm;
	fp = fopen (file, "w");
	nm = gh->nx * gh->ny;
	fwrite ((char *)gh, sizeof (struct GRD_HEADER), 1, fp);
	fwrite ((char *)grid, sizeof (float), nm, fp);
}

