C Single precision matrix inversion routine.
C

c ******************************************************************
c Program written by Dr John GOFF, University of Texas at Austin

c "http://www.ig.utexas.edu/people/staff/goff/"

c Work supported by ONR Awards, 2006-7
c ******************************************************************


      SUBROUTINE matinv(A,B,N,NP,IK,JK)
c smatinv3 from dave's subroutines

      DIMENSION IK(NP),JK(NP)
      DIMENSION A(NP,NP),B(NP,NP)
      REAL A,B,AMAX,SAVE

C
C Copy input matrix A into output matrix B and then invert
C matrix B in place.
C

      DO 10 J=1,N
      DO 10 I=1,N
      B(I,J)=A(I,J)
10    CONTINUE

11    DO 100 K=1,N
C
C Find largest element B(I,J) in rest of matrix.
C
      AMAX=0.0
      DO 30 J=K,N
      DO 30 I=K,N
      IF (ABS(AMAX).LT.ABS(B(I,J))) THEN
        AMAX=B(I,J)
        IK(K)=I
        JK(K)=J
      ENDIF
30    CONTINUE
C
C Interchange rows and columns of matrix to put AMAX in B(K,K)
C (ie. do partial pivoting to improve accuracy).
C
31    IF (AMAX.EQ.0.0) THEN
        WRITE (*,32)
32      FORMAT (1X,'SMATINV3: Warning - matrix is singular.')
        RETURN
      ENDIF

41    I=IK(K)
      IF (I.EQ.K) GOTO 51
      DO 50 J=1,N
      SAVE=B(K,J)
      B(K,J)=B(I,J)
      B(I,J)=-SAVE
50    CONTINUE

51    J=JK(K)
      IF (J.EQ.K) GOTO 61
      DO 60 I=1,N
      SAVE=B(I,K)
      B(I,K)=B(I,J)
      B(I,J)=-SAVE
60    CONTINUE
C
C Accumulate elements of the inverse matrix.
C
61    SAVE=B(K,K)
      DO 70 I=1,N
      B(I,K)=-B(I,K)/AMAX
70    CONTINUE
      B(K,K)=SAVE

      DO 81 J=1,N
      IF (K.EQ.J) GOTO 81
      SAVE=B(K,J)
      DO 80 I=1,N
      B(I,J)=B(I,J)+B(I,K)*SAVE
80    CONTINUE
      B(K,J)=SAVE
81    CONTINUE

      DO 90 J=1,N
      B(K,J)=B(K,J)/AMAX
90    CONTINUE
      B(K,K)=1.0/AMAX
100   CONTINUE
C
C Restore ordering of the matrix.
C
      DO 130 L=1,N
      K=N-L+1
      J=IK(K)
      IF (J.LE.K) GOTO 111
      DO 110 I=1,N
      SAVE=B(I,K)
      B(I,K)=-B(I,J)
      B(I,J)=SAVE
110   CONTINUE
111   I=JK(K)
      IF (I.LE.K) GOTO 130
      DO 120 J=1,N
      SAVE=B(K,J)
      B(K,J)=-B(I,J)
      B(I,J)=SAVE
120   CONTINUE
130   CONTINUE

140   RETURN
      END

