/*--------------------------------------------------------------------
 *    The GMT-system:	@(#)pslib.h	2.1  11/21/91
 *
 *    Copyright (c) 1991 by P. Wessel and W. H. F. Smith
 *    See README file for copying and redistribution conditions.
 *--------------------------------------------------------------------*/
/*
 * Author:	Paul Wessel
 * Date:	9-JAN-1991
 */
#include <ctype.h>
#include <malloc.h>

#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

#define TRUE 1
#define FALSE 0

FILE *ps_file;
int ps_ix, ps_iy;
int ps_npath;
double ps_scl = 0.0;	/* Must be set through plotinit(); */

int ps_arc();
int ps_axis();
int ps_circle();
int ps_clipoff();
int ps_clipon();
int ps_colorimage();
int ps_colortiles();
int ps_comment();
int ps_cross();
int ps_diamond();
int ps_ellipse();
int ps_image();
int ps_imagec();
int ps_imagefill();
int ps_imagergb();
int ps_line();
int ps_pie();
int ps_plot();
int ps_plotend();
int ps_plotinit();
int ps_plotr();
int ps_polygon();
int ps_rect();
int ps_rotatetrans();
int ps_setdash();
int ps_setfont();
int ps_setline();
int ps_setpaint();
int ps_square();
int ps_text();
int ps_textbox();
int ps_transrotate();
int ps_triangle();
int ps_vector();

struct {
  int font_no;
  int mode;
  double xscl, xoff;
  double yscl, yoff;
} ps;

	/* Font information */
	
#define N_FONTS	34	/* Current no of fonts;  To add more, modify the file
			 * PS_font_names.h and PS_font_heights.h and set N_FONTS */

double ps_font_height[N_FONTS] = {	/* Based on the size of A devided by fontsize */
#include "PS_font_heights.h"
};

char *ps_font_name[N_FONTS] = {
#include "PS_font_names.h"
};

	/* Pattern information */
	
#define N_PATTERNS 32	/* Current number of predefined patterns */

char ps_pattern_status[N_PATTERNS][2];
int ps_pattern_nx[N_PATTERNS][2];
int ps_pattern_ny[N_PATTERNS][2];
int ps_pattern_dx[N_PATTERNS][2];
