
c ******************************************************************
c Program written by Dr John GOFF, University of Texas at Austin

c "http://www.ig.utexas.edu/people/staff/goff/"

c Work supported by ONR Awards, 2006-7
c ******************************************************************

      program resamp

      include 'grdhead.inc'
      record /grd_header/ gh
      parameter (nxmax=1000)
      parameter (nymax=1000)
      parameter (nmax=10000)
      parameter (nkmax=10)
      parameter (nimax=50)
      parameter (nbx=200)
      parameter (nby=200)
      parameter (nbz=100)
      real grid1d(nmax)
      real xin(nmax),yin(nmax),zin(nmax),sdin(nmax),din(nmax)
      real xtemp,ytemp,ztemp,stemp,dtemp,avelat,damp
      real zres(nimax,nmax),cs(nkmax,nkmax),csm1(nkmax,nkmax),c0s(nkmax)
      real h,kn,ks,theta,nu,pi,th,ct,st,g0,g0m1,rand_unif,mbsl
      real*8 xint,yint,xmin,xmax,ymin,ymax
      real*8 pweight,totw,weight(nmax),ranpick
      integer ikrig(nkmax),indxi(nkmax),indxj(nkmax),gridopt,unitopt
      integer ibox(nmax),jbox(nmax),nrsbox(nbx,nby),irsbox(nbx,nby,nbz)
      integer isearch(nbz*10)
      character*80 ifile1,ifile2,ofile
c      character*1 ch
      logical rsif(nmax),minif(nbz*10),conif(nxmax,nymax)

c      write (*,*) 'text column x,y,z,sigma file (gridopt = 1) or'
c      write (*,*) 'separate binary grids for z and sigma'
c       read (*,*) gridopt
      gridopt = 1
      
c      write (*,*) 'units option: lat-lon (1) or km-km (2)?'
      unitopt = 1
      
      if (gridopt .eq. 1) then
c         write (*,*) 'enter input x,y,z,sigma file:'
c         read (*,'(a)') ifile1
         ifile1 = '../atl.dir/li_map.dir/lishelf_rc.xyzgr'

c         write (*,*) 'enter output file:'
c         read (*,'(a)') ofile
         ofile = '../atl.dir/li_map.dir/lishelf_res.xyzg'
      
c         write (*,*) 'define search region for nearest neighbors: '
c      #              'xmin, xmax, ymin, ymax'
c         read (*,*) xmin,xmax,ymin,ymax
         xmin = -73.9
         xmax = -71.6
         ymin = 39.95
         ymax = 41.1
      else
c         write (*,*) 'enter input parameter value grid:'
c         read (*,'(a)') ifile1
         ifile1 = '/d3/goff/sedvar.dir/njbath.dir/nj_diff3.gd1'

c         write (*,*) 'enter input parameter sigma grid:'
c         read (*,'(a)') ifile
         ifile2 = '/d3/goff/sedvar.dir/njbath.dir/nj_merge3_u.gd1'

c         write (*,*) 'enter output file:'
c         read (*,'(a)') ofile
         ofile = '/d3/goff/sedvar.dir/njbath.dir/nj_diff3_rs.gd1'

      endif

c      write (*,*) 'enter paramters of the von Karman statistical'
c      write (*,*) 'model: H, Kn, Ks, theta, nu'
c      read (*,*) h, kn, ks, theta, nu
      h = 0.75
      kn = 0.22
      ks = 0.22
      theta = 0
      nu = 0.5
      pi = 3.1415926
      th = pi*theta/180.
      ct = cos(th)
      st = sin(th)
      g0m1 = 1./g0(nu)
      q11 = (kn*ct)**2 + (ks*st)**2
      q12 = (ks**2 - kn**2)*ct*st
      q22 = (kn*st)**2 + (ks*ct)**2

c      write (*,*) 'input seed value for random number generator'
c      write (*,*) 'should be ~8 digits for full effect'
c      read (*,*) iseed
      iseed = 11111111
      
c      write (*,*) 'input damping factor (>1, where 1 = no damping)'
c      read (*,*) damp
      damp = 1.05

c      write (*,*) 'input number of values for kriging'
c      read (*,*) numk
      numk = 10

c      write (*,*) 'input number of iterations'
c      read (*,*) niter
      niter = 20

c      write (*,*) 'input sector box size for nearest neighbor search'
c      read (*,*) bint
      bint = .01

      if (gridopt .eq. 1) then
         open (1,file=ifile1,status='old')
         i = 1
10       read (1,*,end=90) xtemp,ytemp,dtemp,ztemp,stemp
         if (i .ne. 1) then
            do ii = 1,i-1
               if (xtemp .eq. xin(ii) .and. 
     #            ytemp .eq. yin(ii)) goto 10
            enddo
         endif
         xin(i) = xtemp
         yin(i) = ytemp
         din(i) = dtemp
         zin(i) = ztemp
         sdin(i) = stemp
         weight(i) = (1./sdin(i))**2
         i = i + 1
         goto 10
90       close (1)
         ndin = i - 1
         write (*,*) 'ndin: ',ndin

      else
c read in header info - number of rows, number of columns,
c y (row) interval, and x (column) interval.
         ifile1 = ifile1(1:lenb(ifile1))//'\0'
         call bin_read_grd (ifile1,gh,grid1d,nlen)
         nrows = gh.ny
         ncols = gh.nx
         yint = gh.y_inc
         xint = gh.x_inc
         xmin = gh.x_min
         xmax = gh.x_max
         ymin = gh.y_min
         ymax = gh.y_max
         write (*,*) nrows,ncols,xint,xmin,xmax,yint,ymin,ymax
c convert 1-d grid array to 2-d. (1,1) is the lower-left 
c corner of the matrix: z(x,y) or grid(column,row).  Only read
c in non-NaN values as conditions.
         ii = 0
         jj = 0
         do irow = nrows,1,-1
            do icol = 1,ncols
               ii = ii + 1
               if (grid1d(ii) .gt. -999999999.) then 
                  jj = jj + 1
                  zin(jj) = grid1d(ii)
                  xin(jj) = (icol-1)*xint + xmin
                  yin(jj) = (irow-1)*yint + ymin
                  conif(icol,irow) = .true.
               endif
            enddo
         enddo
         ndin = jj
         write (*,*) 'ndin: ',ndin

         ifile2 = ifile2(1:lenb(ifile2))//'\0'
         call bin_read_grd (ifile2,gh,grid1d,nlen)
         ii = 0
         jj = 0
         do irow = nrows,1,-1
            do icol = 1,ncols
               ii = ii + 1
               if (grid1d(ii) .gt. -999999999.) then 
                  jj = jj + 1
                  sdin(jj) = grid1d(ii)
                  weight(jj) = (1./sdin(jj))**2
               endif
            enddo
         enddo
         ndin = jj
         write (*,*) 'ndin: ',jj
      endif
 
c identify sector boxes for each input point for later searching
      nbcols = ifix((xmax-xmin)/bint) + 1
      nbrows = ifix((ymax-ymin)/bint) + 1
      do i = 1,ndin
         ibox(i) = ifix((xin(i)-xmin)/bint) + 1
         jbox(i) = ifix((yin(i)-ymin)/bint) + 1
      enddo

c outer loop over number of resample iterations
      do iter = 1,niter
         write (*,*) 'iteration: ',iter
         do i = 1,ndin
           rsif(i) = .false.
         enddo

c zero out sector box information
         do i = 1,nbx
            do j = 1,nby
               nrsbox(i,j) = 0
               do k = 1,nbz
                  irsbox(i,j,k) = 0
               enddo
            enddo
         enddo

c determine total weight of all values
         totw = 0.
         do i = 1,ndin
            totw = totw + weight(i)
         enddo

c inner loop over all points to be resampled
         do ir = 1,ndin
         
c sum normalized weights of unresampled values until 
c ranpick is reached - this establishes next location
c to be resampled.
50          ranpick = rand_unif(iseed)*totw
            pweight = 0.
            do i = 1,ndin
               if (.not. rsif(i)) then
                  pweight = pweight + weight(i)
                  if (pweight .gt. ranpick) then
                     ipick = i
                     goto 100
                  endif
               endif
            enddo
100         continue

c reset total weight if we've added everything up and we're
c still short
            if (i .eq. ndin .and. pweight .lt. totw) then
               totw = pweight
               goto 50
            endif
            rsif(ipick) = .true.

c reduce total weight by the amount of weight of this
c point to be resampled.
            totw = totw - weight(ipick)

c if this is the first or second point to be resampled, just set 
c it to the original sample value
            if (ir .eq. 1 .or. ir .eq. 2) then
               zres(iter,ipick) = zin(ipick)
c            write (*,*) ipick,zin(ipick),ibox(ipick),jbox(ipick),
c     #                  xin(ipick),yin(ipick)
               goto 900
            endif
        
c find up to numk closest locations among points that have already
c been resampled.  Use L1 norm for speed.
            if (ir .le. numk) then
               nkrig = ir - 1
            else 
               nkrig = numk
            endif
        
c this part of the algorithm is a search over the sector boxes,
c first over the box that the point resides in and the 8 adjacent,
c then in boxes of ever increasing distance until enough previously
c resample points are found to do the kriging for the present one. 
            nor = 1
            nrt = 0
            ib = ibox(ipick)
            jb = jbox(ipick)
            do while (nrt .lt. nkrig)
               if (nor .eq. 1) then
                  do i = 1,nrsbox(ib,jb)
                     nrt = nrt + 1
                     isearch(nrt) = irsbox(ib,jb,i)
                  enddo
                  do ibt = ib-1,ib+1
                     if (ibt .ge. 1 .and. ibt .le. nbcols .and.
     #                  jb-1 .gt. 1) then
                        do i = 1,nrsbox(ibt,jb-1)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ibt,jb-1,i)
                        enddo
                     endif
                  enddo
                  do ibt = ib-1,ib+1
                     if (ibt .ge. 1 .and. ibt .le. nbcols .and.
     #                  jb+1 .le. nbrows) then
                        do i = 1,nrsbox(ibt,jb+1)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ibt,jb+1,i)
                        enddo
                     endif
                  enddo
                  if (ib-1 .ge. 1) then
                     do i = 1,nrsbox(ib-1,jb)
                        nrt = nrt + 1
                        isearch(nrt) = irsbox(ib-1,jb,i)
                     enddo
                  endif
                  if (ib+1 .le. nbcols) then
                     do i = 1,nrsbox(ib+1,jb)
                        nrt = nrt + 1
                        isearch(nrt) = irsbox(ib+1,jb,i)
                     enddo
                  endif
               else
                  do ibt = ib-nor,ib+nor
                     if (ibt .ge. 1 .and. ibt .le. nbcols .and.
     #                  jb-nor .ge. 1) then
                        do i = 1,nrsbox(ibt,jb-nor)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ibt,jb-nor,i)
                        enddo
                     endif
                  enddo
                  do ibt = ib-nor,ib+nor
                     if (ibt .ge. 1 .and. ibt .le. nbcols .and.
     #                  jb+nor .le. nbrows) then
                        do i = 1,nrsbox(ibt,jb+nor)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ibt,jb+nor,i)
                        enddo
                     endif
                  enddo
                  do jbt = jb-nor+1,jb+nor-1
                     if (jbt .ge. 1 .and. jbt .le. nbrows .and.
     #                  ib-nor .ge. 1) then
                        do i = 1,nrsbox(ib-nor,jbt)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ib-nor,jbt,i)
                        enddo
                     endif
                  enddo
                  do jbt = jb-nor+1,jb+nor-1
                     if (jbt .ge. 1 .and. jbt .le. nbrows .and.
     #                  ib+nor .le. nbcols) then
                        do i = 1,nrsbox(ib+nor,jbt)
                           nrt = nrt + 1
                           isearch(nrt) = irsbox(ib+nor,jbt,i)
                        enddo
                     endif
                  enddo
               endif
               nor = nor + 1
               if (ib-nor .lt. 1 .and. ib+nor .gt. nbcols .and.
     #             jb-nor .lt. 1 .and. jb+nor .gt. nbrows) goto 200
            enddo
200         continue 

            do i = 1,nrt
               minif(i) = .false.
            enddo
            do ik = 1,nkrig
               dmin = 999999999.
               do i = 1,nrt
                  ii = isearch(i)
                  if (.not. minif(i)) then
                     tdist = abs(xin(ipick) - xin(ii)) +
     #                       abs(yin(ipick) - yin(ii))
                     if (tdist .lt. dmin) then
                        imin = i
                        dmin = tdist
                     endif
                  endif
                enddo
                ikrig(ik) = isearch(imin)
c                write (*,*) ir,ik,ikrig(ik)
                minif(imin) = .true.
            enddo

c do the kriging
c first define condition covariance matrix
            do i = 1,nkrig
               ii = ikrig(i)
               do j = 1,nkrig
                  jj = ikrig(j)
                  x = xin(ii) - xin(jj)
                  y = yin(ii) - yin(jj)
                  if (gridopt .eq. 1) then
                     avelat = (xin(ii) + xin(jj))/2.0
                     xfac = 111.11111111*cos(avelat*pi/180.)
                     yfac = 111.11111111
                     x = x*xfac
                     y = y*yfac
                  endif
                  if (i .eq. j) then
                     cs(i,j) = damp*h**2
                  else
                     r = sqrt(q11*x*x + 2.*q12*x*y + q22*y*y)
c the following condition shouldn't happen, but does on very rare occasions - probably
c some sort of issue with the search algorithm.  When it does, just ignore that condition.
                     if (r .eq. 0) then
c         write (*,*) ir,i,ii,j,jj,xin(ii),xin(jj),yin(ii),yin(jj)
c         read (*,'(a)') ch
                        cs(i,j) = 0.
                     else
                        xcor = (r**nu)*mbsl(nu,r)*g0m1
                        cs(i,j) = xcor*(h**2)
                     endif
                  endif
               enddo
            enddo

c compute inverse of condition covariance matrix
            call matinv (cs,csm1,nkrig,nkmax,indxi,indxj)

c define data/condition covariance vector
            do i = 1,nkrig
               x = xin(ipick) - xin(ikrig(i))
               y = yin(ipick) - yin(ikrig(i))
               if (gridopt .eq. 1) then
                  avelat = (xin(ipick) + xin(ikrig(i)))/2.0
                  xfac = 111.11111111*cos(avelat*pi/180.)
                  yfac = 111.11111111
                  x = x*xfac
                  y = y*yfac
               endif
               r = sqrt(q11*x*x + 2.*q12*x*y + q22*y*y)
               if (r .eq. 0) then
c         write (*,*) ir,i,ipick,xin(ipick),xin(ikrig(i)),
c     #               yin(ipick),yin(ikrig(i))
c         read (*,'(a)') ch
                  c0s(i) = 0.
               else
                  xcor = (r**nu)*mbsl(nu,r)*g0m1
                  c0s(i) = xcor*(h**2)
               endif
            enddo

c do summation for expected value and variance
            summ = 0.
            sumv = 0.
            do i = 1,nkrig
               sumi = 0.
               do j = 1,nkrig
                  sumi = sumi + c0s(j)*csm1(i,j)
               enddo
               summ = summ + sumi*zin(ikrig(i))
               sumv = sumv + sumi*c0s(i)
            enddo
            varkrig = h**2 - sumv

c determin maximum likelihood resample value
            xm1 = zin(ipick)
            xm2 = summ
            xv1 = (sdin(ipick))**2
            xv2 = varkrig
            zres(iter,ipick) = (xm1*xv2 + xm2*xv1)/(xv1 + xv2)

900         continue
            ib = ibox(ipick)
            jb = jbox(ipick)
            nrsbox(ib,jb) = nrsbox(ib,jb) + 1
            nb = nrsbox(ib,jb)
            irsbox(ib,jb,nb) = ipick
         enddo
      enddo

      if (gridopt .eq. 1) then
c average over iterations and output results
         open (2,file=ofile,status='unknown')
         do j = 1,ndin
            ave = 0.
            do i = 1,niter
               ave = ave + zres(i,j)
            enddo
            ave = ave/float(niter)      
            write (2,*) xin(j),yin(j),din(j),ave,zin(j)
         enddo
         close (2)

      else
c write output to binary file with header  
         write (*,*) 'output grid'    
         ofile = ofile(1:lenb(ofile))//'\0'
         i1d = 0
         jj = 0
         zmin = 1.e30
         zmax = -1.e30
         xnan = sqrt(-1.0)
         do j = 1,nrows
            irow = nrows+1-j
            do i = 1,ncols
               icol = i
               i1d = i1d + 1
               if (conif(icol,irow)) then
                  jj = jj + 1
                  ave = 0.
                  do ii = 1,niter
                     ave = ave + zres(ii,jj)
                  enddo
                  ave = ave/float(niter)
                  grid1d(i1d) = ave
                  zmin = amin1(zmin,grid1d(i1d))
                  zmax = amax1(zmax,grid1d(i1d))
               else
                  grid1d(i1d) = xnan
               endif
            enddo
         enddo
         gh.z_min = zmin
         gh.z_max = zmax

         call bin_write_grd (ofile,gh,grid1d,nlen)
      endif

      stop
      end


