
c ******************************************************************
c Program written by Dr John GOFF, University of Texas at Austin

c "http://www.ig.utexas.edu/people/staff/goff/"

c Work supported by ONR Awards, 2006-7
c ******************************************************************

      subroutine varplot(cor1,mcor,xlag,xn,h,k0,nu,modelif,gaussif)

      parameter (ncm=1000)
      real cor1(ncm),xlag(ncm),pi
      real g0,mbsl,h,k0,nu,nmod(3),hmod(3),k0mod(3),numod(3),bw,bh
      real*8 xx,yy,rx(ncm),ry(ncm),modx(ncm),mody(ncm),pw
      real*8 mx(ncm),my(ncm),angle,lx(2),ly(2),xoff,yoff,xscl,yscl
      logical modelif,addif,gaussif
      character ch*1,title*80,ifile*80,ylabel*10,xcp*10

      pi = 3.1415926
      xcmax = xlag(mcor)
      if (xcmax .lt. 0.02) then
         xlmax = ifix(0.5 + xcmax*1000.)/1000.
      elseif (xcmax .lt. 0.2) then
         xlmax = ifix(0.5 + xcmax*100.)/100.
      elseif (xcmax .lt. 2.) then
         xlmax = ifix(0.5 + xcmax*10.)/10.
      elseif (xcmax .lt. 20.) then
         xlmax = ifix(0.5 + xcmax)
      elseif (xcmax .lt. 200.) then
         xlmax = 10.*(ifix(0.5 + xcmax/10.))
      elseif (xcmax .lt. 2000.) then
         xlmax = 100.*(ifix(0.5 + xcmax/100.))
      else
         xlmax = 1000.*(ifix(0.5 + xcmax/1000.))
      endif

      xvmax = 0.
      do i = 1,mcor
          xvmax = amax1(cor1(i),xvmax)
      enddo
      if (xvmax .lt. 1) then
         xvmax = (ifix(xvmax*1000.) + 1)/1000.
      elseif (xvmax .lt. 20.) then
         xvmax = 1. + ifix(xvmax-0.5)
      elseif (xvmax .lt. 200.) then
         xvmax = 10.*(1 + ifix(xvmax/10.))
      elseif (xvmax .lt. 2000.) then
         xvmax = 100.*(1 + ifix(xvmax/100.))
      elseif (xvmax .lt. 20000.) then
         xvmax = 1000.*(1 + ifix(xvmax/1000.))
      else
         xvmax = 10000.*(1 + ifix(xvmax/10000.))
      endif

c set some plot parameters
      tall = 7.
      wide = 8.0 
      bh = tall - 2.
      bw = wide - 2.
      refh = 1.5    
      refl = 1.0 
      scalel = bw/xlmax
      scaleh = bh/xvmax
      nmod(1) = xn
      hmod(1) = h
      k0mod(1) = k0
      numod(1) = nu
      ncomb = 1
           
100   continue 
c open post-script file, draw border 
      xoff = 0.5
      yoff = 0.5
      pw = 8.5
      xscl = 1.
      yscl = 1.
      ifile = 'varplot.ps\0'
      call ps_plotinit (ifile,0,1,xoff,yoff,
     #                  xscl,yscl,1,300,1,pw)
      call ps_setfont (0)
      call ps_setline (5)
                     
c      x1 = 0.
c      y1 = 0.
c      x2 = wide
c      y2 = tall
c      call ps_rect (x1,y1,x2,y2,255,255,255,1)

c draw axes and tic marks
      tsz = 0.1
      nticks = 5
      lx(1) = refl
      ly(1) = refh
      lx(2) = refl
      ly(2) = bh + refh
      call ps_line(lx,ly,2,3,0)
      lx(2) = refl + bw
      ly(2) = refh
      call ps_line(lx,ly,2,3,0)
      if (xlmax .le. 0.02) then
         do i=1,ifix(1000.*xlmax)+1
            lx(1) = refl + scalel*float(i-1)*.001
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xlmax .le. 0.2) then
         do i=1,ifix(100.*xlmax)+1
            lx(1) = refl + scalel*float(i-1)*.01
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xlmax .le. 2 .and. xlmax .gt. 0.2) then
         do i=1,ifix(10.*xlmax)+1
            lx(1) = refl + scalel*float(i-1)*.1
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xlmax .le. 20 .and. xlmax .gt. 2.) then
         do i=1,ifix(xlmax)+1
            lx(1) = refl + scalel*float(i-1)
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xlmax .le. 200 .and. xlmax .gt. 20.) then
         do i=1,ifix(xlmax/10.)+1
            lx(1) = refl + scalel*float(i-1)*10.
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      else 
         do i=1,ifix(xlmax/100.)+1
            lx(1) = refl + scalel*float(i-1)*100.
            ly(1) = refh
            lx(2) = lx(1)
            ly(2) = refh + tsz
            call ps_line(lx,ly,2,3,0)
         enddo
      endif

      if (xvmax .lt. 0.02) then
         do i=1,ifix(1000.*xvmax)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*0.001
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .lt. 0.2) then
         do i=1,ifix(100.*xvmax)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*0.01
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .le. 2 .and. xvmax .gt. 0.2) then
         do i=1,ifix(10.*xvmax)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*0.1
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .le. 20 .and. xvmax .gt. 2.) then
         do i=1,ifix(xvmax)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .le. 200 .and. xvmax .gt. 20.) then
         do i=1,ifix(xvmax/10.)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*10.
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .le. 2000 .and. xvmax .gt. 200) then
         do i=1,ifix(xvmax/100.)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*100.
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      elseif (xvmax .le. 20000 .and. xvmax .gt. 2000) then
         do i=1,ifix(xvmax/1000.)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*1000.
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      else 
         do i=1,ifix(xvmax/10000.)+1
            lx(1) = refl 
            ly(1) = refh + scaleh*(i-1)*10000.
            lx(2) = refl + tsz
            ly(2) = ly(1)
            call ps_line(lx,ly,2,3,0)
         enddo
      endif

c draw labels                               
      xx = refl + bw/2.
      yy = refh - 0.6
      title = 'LAG, km\0'
      angle = 0.
      call ps_text (xx,yy,20,title,angle,2,0)
      title = 'Semi-variogram, (phi)@+2@+\0'
      xx = refl - 0.5
      yy = refh + bh/2.
      angle = 270.
      call ps_text (xx,yy,20,title,angle,2,0)

      if (xlmax .le. 0.02) then
         write (xcp,'(f5.3)') xlmax
      elseif (xlmax .le. 0.2 .and. xlmax .gt. 0.02) then
         write (xcp,'(f4.2)') xlmax
      elseif (xlmax .le. 2. .and. xlmax .gt. 0.2) then
         write (xcp,'(f3.1)') xlmax
      elseif (xlmax .lt. 100) then
         write (xcp,'(i2)') ifix(xlmax)
      elseif (xlmax .lt. 1000) then
         write (xcp,'(i3)') ifix(xlmax) 
      else
         write (xcp,'(i4)') ifix(xlmax) 
      endif
      xcp = xcp(1:lenb(xcp))//'\0'
      yy = refh - tsz
      xx = refl + bw
      angle = 0.
      call ps_text (xx,yy,20,xcp,angle,10,0)
      xx = refl
      call ps_text (xx,yy,20,'0\0',angle,10,0)
      xx = refl - tsz
      yy = refh + bh 
      if (xvmax .ge. 100000) then
         write (ylabel,'(i6)') ifix(xvmax)
      elseif (xvmax .ge. 10000) then 
         write (ylabel,'(i5)') ifix(xvmax)
      elseif (xvmax .ge. 1000) then
         write (ylabel,'(i4)') ifix(xvmax)
      elseif (xvmax .ge. 100) then
         write (ylabel,'(i3)') ifix(xvmax)
      elseif (xvmax .ge. 10) then
         write (ylabel,'(i2)') ifix(xvmax)
      elseif (xvmax .ge. 1) then
         write (ylabel,'(i1)') ifix(xvmax)
      else
         write (ylabel,'(f6.4)') xvmax
      endif
      ylabel = ylabel(1:lenb(ylabel))//'\0'
      call ps_text (xx,yy,20,ylabel,angle,7,0) 
      yy = refh
      call ps_text (xx,yy,20,'0\0',angle,7,0)

c plot cor1
      call ps_setdash ('\0',0)
      do i=1,mcor
         rx(i) = xlag(i)*scalel + refl
         ry(i) = cor1(i)*scaleh + refh
      enddo
      call ps_line(rx,ry,mcor,3,0)

c if desired, plot model 
      if (modelif) then
         do i = 1,mcor
            mody(i) = 0.
            modx(i) = xlag(i)
         enddo
         do ic = 1,ncomb
            xg = g0(numod(ic))
            do i=1,mcor
               r = xlag(i)*k0mod(ic)
               if (gaussif) then
                  xm = hmod(ic)*exp(-pi*(r**2))
                  mody(i) = mody(i) + xm
               else
                  if (r .eq. 0.0) then
                     xm = nmod(ic)
                  else
                     xm = nmod(ic) + hmod(ic)*(1. - 
     #                    (r**numod(ic))*mbsl(numod(ic),r)/xg)
                  endif
                  mody(i) = mody(i) + xm
               endif
            enddo
         enddo
c         else
c            xg = g0(numod)
c            do i=1,mcor
c               r = xlag(i)*k0mod
c               if (gaussif) then
c                  mody(i) = hmod*exp(-pi*(r**2))
c               else
c                  if (r .eq. 0.0) then
c                     mody(i) = hmod
c                  else
c                     mody(i) = hmod*(r**numod)*mbsl(numod,r)/xg
c                  endif
c               endif
c               modx(i) = xlag(i)
c            enddo
c         endif
c plot model
         do i=1,mcor
            mx(i) = modx(i)*scalel + refl
            my(i) = mody(i)*scaleh + refh
         enddo
         call ps_setdash ('20 20',0)
         call ps_line(mx,my,mcor,3,0)
      endif
      call ps_setdash ('\0',0)

      call ps_plotend (1)

      write (*,*) 'Please wait while plot is generated in ghostscript.'
      write (*,*) 'Close window after viewing and press <return>'
      write (*,*) 'to continue (ignore "broken pipe" message)'
      n = system('gs varplot.ps')

c      read (*,'(a)') ch
      

c      write (*,*) 'change gaussif?'
c      read (*,'(a)') ch
c      if (ch .eq. 'y') then
c         if (gaussif) then
c            gaussif = .false.
c         else
c            gaussif = .true.
c         endif
c      endif

      addif = .false.
      modelif = .false.
      if (gaussif) then
         write (*,*) 'would you like to ovarlay Gaussian model?'
         read (*,'(a)') ch
         if (ch .eq. 'y') then
            ncomb = 1
            write (*,*) 'input parameters N2, H2, Kg:'
            read (*,*) nmod(1),hmod(1),k0mod(1)
            modelif = .true.
            goto 100
         endif

      else

         write (*,*) 'would you like to overlay von Karman model?'
         read (*,'(a)') ch
         if (ch .eq. 'y') then
            write (*,*) '1, 2, or 3 combined models?'
            read (*,*) ncomb
            do ic = 1,ncomb
               write (*,*) 'input N2, H2, Ko, nu for model ',ic
               read (*,*) nmod(ic),hmod(ic),k0mod(ic),numod(ic)
            enddo
            modelif = .true.
            goto 100
         endif

      endif

      return
      end
